{bot}
{channelbot is a channel service with a design similar to quakenets Q and L}
{existing L channel data may be converted USING l2c}
{channelbots default nick is C}

(*
 *  beware IRC services, channelbot.pas
 *  Copyright (C) 2003 Peter Green
 *  Portions Copyright (C) 2002 Bas Steendijk
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit channelbot;

interface
uses
  accountUSINGbot , buser , bchannel , chanflagstuff;


type

  tchannelbot = class(taccountUSINGbot)
  public
    locopt:record
      overridelevel : integer;
      regchanlifetime:integer;
    end;
    procedure setupsrvunit;override;
    procedure buildoptiontable;override;
    constructor create;
    procedure loadaccountdependent;override;
    procedure botsave(saveall:boolean);override;
    function checkcommandaccess(us:tuser;channel:string;accesstype:integer) : integer;
    function hasvoice(us:tuser;ch:tchannel):integer;override;
    function hasop(us:tuser;ch:tchannel):integer;override;
    function hasmaster(us:tuser;ch:tchannel):integer;override;
//    function checksuspended(us:tuser;channel:string):boolean;
    procedure expirechannels;
    procedure localtimehandler; override;
    function isregisteredchan(channel:string):boolean;override;
    procedure updatelimits;
  end;

var
  channelbotobject : tchannelbot;

implementation

uses
  channelcommands , boptiontable    , accountcore , pgtypes , channeldb ,
  bstuff          , bparse          , bcmds       , btime   , bconsts   ,
  generalreplies  , channel_replies ;

procedure ondestroyaccount(ac : taccount;tag:taddrint);
begin
  while ac.bottag[channelbotobject.srvunit.num] <> nil do begin
    deluserfromreggedchannel(ac,taccountreggedchan(ac.bottag[channelbotobject.srvunit.num]).ch,taccountreggedchan(ac.bottag[channelbotobject.srvunit.num]));
  end;
end;

procedure onjoinchannel(channel:tchannel;source:tuser;target:tuser;flags:byte;message:string;tag:taddrint);
var
  uc : tuserchan;
  rch : treggedchannel;
begin
  with tchannelbot(tag) do begin
    if not up then exit;
    uc := getuserchan(target,channel);

    if checkcommandaccess(target,channel.name,chanlev_auto)= access_true then begin
      if checkcommandaccess(target,channel.name,chanlev_op)= access_true then begin
        if not flag_isset(uc.flags,userchanflag_op) then begin
          sendparse(mybot.idstr+' '+tok_mode+' '+channel.name+' +o '+target.idstr);
        end;
        if flag_isset(uc.flags,userchanflag_voice) then begin
          sendparse(mybot.idstr+' '+tok_mode+' '+channel.name+' -v '+target.idstr);
        end;
      end else begin
        if (not flag_isset(uc.flags,userchanflag_op))and(not flag_isset(uc.flags,userchanflag_voice)) then begin
          sendparse(mybot.idstr+' '+tok_mode+' '+channel.name+' +v '+target.idstr);
        end;
      end;
    end else if checkcommandaccess(target,channel.name,chanlev_autovoiceonly)= access_true then begin
      if (not flag_isset(uc.flags,userchanflag_op))and(not flag_isset(uc.flags,userchanflag_voice)) then begin
        sendparse(mybot.idstr+' '+tok_mode+' '+channel.name+' +v '+target.idstr);
      end;
    end else if checkcommandaccess(target,channel.name,chanlev_banned)= access_true then begin
      sendparse(mybot.idstr+' '+tok_mode+' '+channel.name+' +b '+target.name+'!'+target.userid+'@'+target.host);
      sendparse(mybot.idstr+' '+tok_kick+' '+channel.name+' '+target.idstr+' :'+banmessage_chanflagb);
    end;
    rch := findreggedchan(channel.name);
    if assigned(rch) then begin

      if checkcommandaccess(target,channel.name,chanlev_owner)= access_true then begin
        rch.lastseents := irctime;
      end;

      if (rch.flags and chanflag_welcomemessage) <> 0 then begin
        send(sendtalkstr(mybot,target)+'['+channel.name+'] '+rch.welcome);
      end;
    end;
  end;
end;

procedure ontopic(channel:tchannel;source:tuser;var bounce:boolean;tag:taddrint);
var
  rch : treggedchannel;

procedure accept;
begin
  rch.topic := channel.topic;
  rch.topicts := channel.topictime;
end;

begin
  with tchannelbot(tag) do begin
    if not up then exit;
    rch := findreggedchan(channel.name);
    if not assigned(rch) then exit;
    if rch.topic = channel.topic then exit; {no change, ignore}
    if (rch.flags and chanflag_forcetopic) = 0 then begin accept; exit end;
    if isserver(source) or flag_isset(source.modeflag,usermode_service) then begin accept; exit end;
    if (checkcommandaccess(source,channel.name,chanlev_topic)<>access_false) or
    (checkcommandaccess(source,channel.name,chanlev_master)<>access_false)  then begin accept; exit end;
    {here, bounce topic}
    bounce := true;
    sendparse(mybot.idstr+' '+TOK_TOPIC+' '+channel.name+' :'+rch.topic);
  end;
end;

procedure onsendeob(tag:taddrint);
var
  rch:treggedchannel;
  a:integer;
begin
  with tchannelbot(tag) do begin
    rch := treggedchannel(globalreggedchanlist);
    while assigned(rch) do begin
      if (rch.flags and chanflag_forcetopic) <> 0 then a := 0 else a := rch.topicts;
      if (rch.topic <> '') then {if (rch.topic <> ch.topic) or (rch.topicts <> ch.topictime) then}
      sendparse(mybot.idstr+' '+TOK_TOPIC+' '+rch.name+' '+inttostr(a)+' :'+rch.topic);

      rch := treggedchannel(rch.next);
    end;
  end;
end;

procedure onlogin(us:tuser;ac:taccount;tag:taddrint);
var
  uc : tuserchan;
begin
  uc := tuserchan(us.channel);
  while assigned(uc) do begin
    onjoinchannel(uc.ch,us,us,0,'',tag);
    uc := tuserchan(uc.next);
  end;
end;

procedure onop(source:tuser;target:tuser;channel:tchannel;modetype:tmodetype;tag:taddrint);
var
  rch : treggedchannel;
begin
  with tchannelbot(tag) do begin
    if source=target then exit;
    rch := findreggedchan(channel.name);
    if rch = nil then exit;
    if (hasop(target,channel)=access_false) and ((rch.flags and chanflag_bitch) <>0) then begin
      sendparse(botmodestring(mybot,channel)+' -o '+target.idstr);
    end;
  end;
end;

procedure ondeop(source:tuser;target:tuser;channel:tchannel;modetype:tmodetype;tag:taddrint);
var
  rch : treggedchannel;
begin
  with tchannelbot(tag) do begin
    if source=target then exit;
    rch := findreggedchan(channel.name);
    if rch = nil then exit;
    if (hasop(target,channel)=access_true) and ((rch.flags and chanflag_protectops) <>0) then begin
      sendparse(botmodestring(mybot,channel)+' +o '+target.idstr);
    end;
  end;
end;
procedure onchanmode(source:tuser;channel:tchannel;oldflags:integer;oldkey:string;oldlimit:integer;modetype:tmodetype;tag:taddrint);
var
  rch : treggedchannel;
begin
  with tchannelbot(tag) do begin
    if (source.modeflag and usermode_service)=0 then begin //we do not fight with other services
      rch := findreggedchan(channel.name);
      if rch = nil then exit;
      if ((channel.modeflag and chanmode_inviteonly)=0) and ((rch.flags and chanflag_forceinvite) <>0) then begin
        sendparse(botmodestring(mybot,channel)+' +i');
      end;
      if (channel.limit<>rch.limit) and ((rch.flags and chanflag_forcelimit) <>0) then begin
        if rch.limit <> 0 then begin
          sendparse(botmodestring(mybot,channel)+' +l '+inttostr(rch.limit));
        end else begin;
          sendparse(botmodestring(mybot,channel)+' -l');
        end;
      end;
      if (channel.key<>rch.key) and ((rch.flags and chanflag_forcekey) <>0) then begin
        if rch.key <> '' then begin
          sendparse(botmodestring(mybot,channel)+' +k '+rch.key);
        end else begin;
          sendparse(botmodestring(mybot,channel)+' -k');
        end;
      end;
    end;
  end;
end;

procedure tchannelbot.setupsrvunit;
begin
  inherited setupsrvunit;
  //srvunit := createserviceunit;
  srvunit.name := 'channel';
{  taccountUSINGserviceunit(srvunit).onnewaccount := onnewaccount;}
  taccountUSINGserviceunit(srvunit).ondestroyaccount := ondestroyaccount;
  taccountUSINGserviceunit(srvunit).onlogin          := onlogin;
  srvunit.onjoinchannel                               := onjoinchannel;
  srvunit.ontopic                                     := ontopic;
  srvunit.onsendeob                                   := onsendeob;
  srvunit.onop                                        := onop;
  srvunit.ondeop                                      := ondeop;
  srvunit.onchanmode                                  := onchanmode;
end;

constructor tchannelbot.create;
begin
  inherited create;
  cmdtab := @channelcommands.cmdtab;
  botmaxcmd := channelcommands.botmaxcmd;
  buildsorted;
  commandsfile:='channel.com.ini';
  configfile:='channel.ini';
  cfgtag:='[Channel]';
  //accountsfile='auth.accounts.ini';
  //emailbanfile:='auth.emailban.ini';

  botlogfile:='channel.log';
  //authmailfile:='authmail.txt';
  //requestpassmailfile:='requestpassmail.txt';
  changestringoptiondefault(optiontable^,maxoptiontable,'nick','C');
  changestringoptiondefault(optiontable^,maxoptiontable,'info','beware IRC channel Service');
end;

procedure tchannelbot.buildoptiontable;
var
  startat : integer;
begin
  startat := maxoptiontable+1;
  inc(maxoptiontable,2);

  inherited buildoptiontable;
  with optiontable[startat] do begin
    p:=@locopt.overridelevel;
    typ:=opt_int;
    name:='overridelevel';
    info:='minimum level of user who has no need for channel access when doning things to a channel';
    def_i:=900;
  end;
  with optiontable[startat+1] do begin
    p:=@locopt.regchanlifetime;
    typ:=opt_int;
    name:='regchanlifetime';
    info:='the channel expires if an owner has joined for this long, in seconds';
    def_i:=40*86400;
  end;
end;

procedure tchannelbot.loadaccountdependent;
begin
  loadchannels;
end;

procedure tchannelbot.botsave;
begin
  inherited botsave(saveall);
  savechannels;
end;

function tchannelbot.checkcommandaccess(us:tuser;channel:string;accesstype:integer):integer;
var
  rch                : treggedchannel     ;
  ac                 : taccount           ;
  arc                : taccountreggedchan ;
begin
  if (haslevel(us) >= locopt.overridelevel) then begin
    result := access_override;
  end else begin
    result := access_false;
  end;
  rch := findreggedchan(channel);
  ac  := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(us);
  if (ac=nil) or (rch=nil) then begin
    exit;
  end;
  arc := getaccountreggedchan(ac,rch);
  if (arc=nil) or ((rch.flags and chanflag_suspended)<>0) then begin
    exit;
  end;
  if (arc.flags and accesstype) <> 0 then begin
    result := access_true
  end;


end;

function tchannelbot.hasvoice(us:tuser;ch:tchannel):integer;
begin
  result := checkcommandaccess(us,ch.name,chanlev_voice);
end;

function tchannelbot.hasop(us:tuser;ch:tchannel):integer;
begin
  result := checkcommandaccess(us,ch.name,chanlev_op);
end;

function tchannelbot.hasmaster(us:tuser;ch:tchannel):integer;
begin
  result := checkcommandaccess(us,ch.name,chanlev_master);
end;

{function tchannelbot.checksuspended(us:tuser;channel:string):boolean;
var
  rch : treggedchannel;
begin
  if (haslevel(us) >= locopt.overridelevel) then begin
    result := false;// a user with ovevrridelevel can work on a suspended channel
  end else begin
    rch := findreggedchan(channel);
    result := (rch.flags and chanflag_suspended)<>0;
  end;
end;}

procedure tchannelbot.expirechannels;
var
  rch,rch2:treggedchannel;
begin
  if unixtime and 1023 <> 0 then exit;
  if locopt.regchanlifetime = 0 then exit;
  rch := treggedchannel(globalreggedchanlist);
  while assigned(rch) do begin
    rch2 := treggedchannel(rch.next);
    if (rch.lastseents <> 0) then if rch.lastseents < irctime-locopt.regchanlifetime then begin
      //logaction(nil,'registered channel '+rch.name+' expired');
      logaction(nil,replacealias(log_channelexpired,'%channel%',rch.name));

      rch.destroy;
    end;
    rch := rch2;
  end;
end;

procedure tchannelbot.localtimehandler;
begin
  if irctime and 7 = 0 then expirechannels;
  if irctime and 15 = 0 then updatelimits;
end;

function tchannelbot.isregisteredchan(channel:string):boolean;
begin
  result := assigned(findreggedchan(channel));
end;

procedure tchannelbot.updatelimits;
var
  currentchan : treggedchannel;
  ch          : tchannel;
begin
  currentchan := treggedchannel(globalreggedchanlist);
  while assigned(currentchan) do begin
    if (currentchan.flags and chanflag_autolimit) <> 0 then begin
      ch := findchan(currentchan.name);
      if assigned(ch) then begin
        if ((ch.limit*100) < ((ch.usercount *100)+(currentchan.autolimit*75)))
         or ((ch.limit*100) < ((ch.usercount *100)+(currentchan.autolimit*125)))
         then begin
          sendparse(botmodestring(mybot,ch)+' +l '+inttostr(ch.usercount+currentchan.autolimit));
        end;
      end;
    end;
    currentchan := treggedchannel(currentchan.next);
  end;
end;


initialization
  channelbotobject := tchannelbot.create;
end.
