unit replymanager;
interface
uses blinklist,bcrash,unitwritetxt,replystuff;
type
  pstring=^string;
  treply=class(tlinklist)
    p : pstring;
    name : string;
    default : string;
    version : integer;
  end;
procedure addreply(np : pstring;nname : string;ndefault : string;nversion:integer);
procedure reply_default;
procedure reply_save;
procedure reply_load;
function  setreplyescaped(name,value:string;version:integer) : boolean;
function getreplyescaped(name:string) : string;
var
  replylist : tlinklist;
implementation
uses
  sysutils,readtxt;
const
  replysfile='bewareserv.replies.ini';

procedure addreply(np : pstring;nname : string;ndefault : string;nversion:integer);
var
  link : treply;
begin
  link := treply(replylist);

  while assigned(link) do begin
    assert(not(uppercase(link.name)=uppercase(nname)),'duplicate reply name',link.name+' '+nname);
    link := treply(link.next);
  end;
  link := treply.create;
  link.p :=np;
  link.name := nname;
  link.default := ndefault;
  link.version := nversion;
  linklistadd(replylist,link);

end;

procedure reply_default;
var
  link : treply;
begin
  link := treply(replylist);

  while assigned(link) do begin

    link.p^ := link.default;
    link := treply(link.next);
  end;
end;
function getreplyescapedinternal(link : treply) : string;
var
  counter : integer;
begin
  result :='';
  for counter := 1 to length(link.p^) do begin
    case (link.p^)[counter] of
      'A'..'Z','a'..'z','0'..'9',' ' : begin
        result := result + (link.p^)[counter];
      end;
      else begin
        result := result +'!'+inttohex(ord((link.p^)[counter]),2)+'!';
      end;
    end;
  end;
end;

function getreplyescaped(name:string) : string;
var
  link : treply;
begin
  link := treply(replylist);

  while assigned(link) do begin

    if uppercase(link.name)=uppercase(name) then begin
      result := getreplyescapedinternal(link);
      exit;
    end;
    link := treply(link.next);
  end;
  result := '';

end;



procedure reply_save;
var
  t : text;
  link : treply;
  counter : integer;
  linetosave : string;
begin
  if openforwrite(t,replysfile) then begin
    link := treply(replylist);

    while assigned(link) do begin

      //link.p^ := link.default;
      linetosave := getreplyescapedinternal(link);
      if link.version = 0 then begin
        writeln(t,link.name+'='+linetosave);
      end else begin
        writeln(t,link.name+':'+inttostr(link.version)+'='+linetosave);
      end;
      link := treply(link.next);
    end;

    closefile(t)
  end;
end;

procedure reply_load;
var
  t                                  : treadtext ;
  line    , name    , value , value2 : string    ;
  version , counter                  : integer   ;
  link                               : treply    ;

begin
  if readtext_init(t,replysfile) then begin;
    while not readtext_eof(t) do begin
      //writeln(line);
      line := readtext_line(t);
      name := copy(line,1,pos('=',line)-1);
      if pos(':',name)=0 then begin
        version := 0;
      end else begin
        version := strtoint(copy(name,pos(':',name)+1,65535));
        setlength(name,pos(':',name)-1);
      end;

      value := copy(line,pos('=',line)+1,65535);
      setreplyescaped(name,value,version);
    end;

  end;
end;

function setreplyescaped(name,value:string;version:integer):boolean;
var
  value2  : string  ;
  link    : treply  ;
  counter : integer ;
begin
  result := false;
  value2 := '';
  counter := 1;
  while counter <= length(value) do begin
    case value[counter] of
      '!' : begin
        if (stringchardef(value,counter+1,#0) in ['a'..'f','A'..'F','0'..'9'])and(stringchardef(value,counter+2,#0) in ['a'..'f','A'..'F','0'..'9'])and (stringchardef(value,counter+3,#0) = '!') then begin
          value2 := value2+char(strtoint('$'+value[counter+1]+value[counter+2]));
          inc(counter,3);
        end else begin
          value2 := value2 + '!';
        end;
      end;
      else begin
        value2 := value2 +value[counter];
      end;
    end;
    inc(counter);
  end;
  link := treply(replylist);
  while assigned(link) do begin
    if uppercase(link.name) = uppercase(name) then begin
      if (link.version = version) or (version=-1) then begin
        //if (link.p^) <> value2 then begin
        //  writeln('reply change detected');
        //  writeln('old:'+link.p^);
        //  writeln('new:'+value2);
        //  writeln('fromfile:'+value);
        //end;
        link.p^ := value2;
        result := true;
      end;
    end;
    //link.p^ := link.default;
    link := treply(link.next);
  end;

end;


end.
